<?php

namespace RxConnexionBundle\Controller;

use RxConnexionBundle\Entity\TreatmentPlanEntity;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;

use RxConnexionBundle\Entity\AuditTrailEntity;
use RxConnexionBundle\Form\TreatmentPlanForm;

/**
 * @Route("/main/treatment_plan")
 */
class TreatmentPlanController extends Controller
{
    /**
     * @Route("", name="treatment_plan")
     */
    public function indexAction() {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Treatment Plan CMS'))) return $authService->redirectToHome();

        return $this->render('@RxConnexion/TreatmentPlan/index.html.twig', array(
            'title' => 'Manage Treatment Plan',
            'page_title' => 'Manage Treatment Plan',
            'javascripts' => array('rxconnexion/admin/js/treatmentPlan/treatmentPlan.js?v=1.0.0')
        ));
    }

    /**
     * @Route("/ajax_list", name="treatment_plan_ajax_list")
     */
    public function ajax_list(Request $request) {

        $get = $request->query->all();

        $result = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => 0,
            "recordsFiltered" => 0,
            "data" => array()
        );

        $authService = $this->get('rx_connexion.authService');
        if($authService->isLoggedIn()) {

            $hasUpdate = $authService->isUserHasAccesses(array('Admin Treatment Plan Update'), false);

            $data = $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:TreatmentPlanEntity')->ajax_list($get, $this->get('session')->get('userData'));

            foreach($data['results'] as $row) {

                $id = base64_encode($row['id']);
                $action = '';

                if($hasUpdate) {
                    $url = $this->generateUrl('treatment_plan_form', array(
                        'action' => 'u',
                        'id' => $id
                    ));
                    $action = "<a class='action-button-style' href='$url'>Update</a>";
                }

                $values = array(
                    $row['code'],
                    $row['description'],
                    $action
                );

                $result['data'][] = $values;
            }

            $result['recordsTotal'] = $data['total'];
            $result['recordsFiltered'] = $data['total'];
        }

        return new JsonResponse($result);
    }

    /**
     * @Route(
     *      "/form/{action}/{id}",
     *      defaults = {
     *          "action":  "n",
     *          "id": 0
     *      },
     *      requirements = {
     *          "action": "n|u"
     *      },
     *      name = "treatment_plan_form"
     * )
     */
    public function formAction($action, $id, Request $request) {

        $authService = $this->get('rx_connexion.authService');
        if(!$authService->isLoggedIn()) return $authService->redirectToLogin();
        if(!$authService->isUserHasAccesses(array('Admin Treatment Plan New', 'Admin Treatment Plan Update'))) return $authService->redirectToHome();

        $em = $this->getDoctrine()->getManager();

        $treatmentPlan = $em->getRepository('RxConnexionBundle:TreatmentPlanEntity')->find(base64_decode($id));
        if(!$treatmentPlan) {
            $treatmentPlan = new TreatmentPlanEntity();
        }

        $formOptions = array('action' => $action);
        $form = $this->createForm(TreatmentPlanForm::class, $treatmentPlan, $formOptions);

        if($request->getMethod() === 'POST') {

            $treatmentPlan_form = $request->get($form->getName());
            $result = $this->processForm($treatmentPlan_form, $treatmentPlan, $form, $request);

            if($result['success']) {
                if($result['redirect'] === 'index') {
                    return $this->redirect($this->generateUrl('treatment_plan'), 302);
                } else if($result['redirect'] === 'form') {
                    return $this->redirect($this->generateUrl('treatment_plan_form', array(
                        'action' => 'u',
                        'id' => base64_encode($result['id'])
                    )), 302);
                } else if($result['redirect'] === 'form with error') {
                    return $this->redirect($this->generateUrl('treatment_plan_form'), 302);
                }
            } else {
                $form->submit($treatmentPlan_form, false);
            }
        }

        $title = ($action === 'n' ? 'New' : 'Update') . ' Treatment Plan';

        return $this->render('@RxConnexion/TreatmentPlan/form.html.twig', array(
            'title' => $title,
            'page_title' => $title,
            'javascripts' => array('rxconnexion/admin/js/treatmentPlan/treatmentPlan_form.js?v=1.0.0'),
            'form' => $form->createView(),
            'action' => $action,
            'id' => $id
        ));
    }

    private function processForm($treatmentPlan_form, $treatmentPlan, $form, Request $request) {

        $em = $this->getDoctrine()->getManager();

        $errors = $em->getRepository('RxConnexionBundle:TreatmentPlanEntity')->validate($treatmentPlan_form);

        if(!count($errors)) {

            switch($treatmentPlan_form['action']) {

                case 'n': // new

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $em->persist($treatmentPlan);
                        $em->flush();

                        $newAT = new AuditTrailEntity(
                            'Treatment Plan',
                            $em->getClassMetadata(TreatmentPlanEntity::class)->getTableName(),
                            AuditTrailEntity::AXN_NEW
                        );
                        $newAT->entity = $treatmentPlan;
                        $newAT->parseDetails();
                        $em->persist($newAT);
                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Saved.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'u': // update

                    $newAT = new AuditTrailEntity(
                        'Treatment Plan',
                        $em->getClassMetadata(TreatmentPlanEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_UPDATE
                    );
                    $newAT->entity = $treatmentPlan;
                    $newAT->parseOriginalDetails();

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        $newAT->parseDetails();
                        $em->persist($newAT);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Updated.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;

                case 'd': // delete

                    $newAT = new AuditTrailEntity(
                        'Treatment Plan',
                        $em->getClassMetadata(TreatmentPlanEntity::class)->getTableName(),
                        AuditTrailEntity::AXN_DELETE
                    );
                    $newAT->entity = $treatmentPlan;
                    $newAT->parseDetails();
                    $em->persist($newAT);

                    $form->handleRequest($request);

                    if ($form->isValid()) {

                        //$em->remove($service);
                        $treatmentPlan->setIsDeleted(true);

                        $em->flush();

                        $this->get('session')->getFlashBag()->set('success_messages', 'Record Successfully Deleted.');

                        $result['redirect'] = 'index';

                    } else {

                        $this->get('session')->getFlashBag()->set('error_messages', 'Something went wrong. Please try again.');
                        $result['redirect'] = 'form with error';
                    }

                    break;
            }

            $result['success'] = true;

        } else {

            foreach($errors as $error) {
                $this->get('session')->getFlashBag()->add('error_messages', $error);
            }

            $result['success'] = false;
        }

        return $result;
    }

    /**
     * @Route("/autocomplete", name="treatment_plan_autocomplete")
     */
    public function autocompleteAction(Request $request) {

        $q = $request->get('query');

        $result = array(
            'query' => 'descriptions',
            'suggestions' => $this->getDoctrine()->getManager()->getRepository('RxConnexionBundle:TreatmentPlanEntity')->autocomplete_suggestions($q)
        );

        return new JsonResponse($result);
    }
}
